package com.sourcelabs.zipper;

import com.sourcelabs.zipper.zip.ZipEntry;

import java.util.Iterator;
import java.util.Enumeration;
import java.nio.ByteBuffer;

/**
 * @author willpugh  Mar 4, 2006 11:12:37 PM
 */
public class EntryIterator implements Iterator, Enumeration {

    ByteBuffer      bb;
    ZipEntry        next;

    public EntryIterator(ByteBuffer bb) {
        this.bb = bb.duplicate();
        this.bb.position(0);
        this.bb.order(bb.order());
        loadNext();
        if (next.isLengthAtEnd())
            throw new IllegalArgumentException("Can't use the Entity Iterator with zip files that don't have a length in the headers.  Please use the IndexIterator");
    }

    protected void loadNext() {
        int     nextPos = 0;
        if (next != null) {
            nextPos = bb.position() + next.getCompressedSize();
            bb.position(nextPos);
        }

        next = new ZipEntry("");
        try {
            next.load(bb);
        } catch (SignatureMismatchException e) {
            next = null;
        }
    }

    public boolean hasNext() {
        return next != null;
    }

    public Object next() {
        ZipEntry   retVal = next;
        loadNext();
        return retVal;
    }

    public void remove() {
        throw new UnsupportedOperationException();
    }

    public boolean hasMoreElements() {
        return hasNext();
    }

    public Object nextElement() {
        return next();
    }
}
