package com.sourcelabs.zipper;

import com.sourcelabs.zipper.zip.ZipEntryImpl;
import com.sourcelabs.zipper.zip.ZipIndex;

import java.util.Iterator;
import java.util.Enumeration;
import java.nio.ByteBuffer;

/**
 * @author willpugh  Mar 4, 2006 11:23:18 PM
 */
public class IndexIterator implements Iterator, Enumeration {
    ByteBuffer      bb;
    ZipIndex        index;
    int             curr = 0;

    public IndexIterator(ByteBuffer bb, ZipIndex index) throws InvalidZipFormatException {
        this.bb = bb.duplicate();
        this.bb.order(bb.order());
        this.index = index;
        if (!index.isLoaded())
            index.load(bb);
    }

    public boolean hasNext() {
        return (index.getCount() > curr);
    }

    public Object next() {
        ZipEntryImpl retVal = null;
        if (hasNext()) {
            retVal = index.getEntry(curr++, bb);
        }
        return retVal;
    }

    public void remove() {

    }

    public boolean hasMoreElements() {
        return hasNext();
    }

    public Object nextElement() {
        return next();
    }

}
