package com.sourcelabs.zipper.zip;

import java.io.InputStream;
import java.io.OutputStream;

/**
 * @author willpugh  Apr 6, 2006 11:36:10 PM
 */
public interface ZipCallback {

    //This means the callback did not want to do anything and the zip file
    //should process this file
    public static final int PROCESS_ENTRY = 0;

    //This means the callback processed this entry, and wrote the uncompressed
    //output body to the output stream.  The zip file should use that body for
    //the entry
    public static final int ENTRY_PROCESSED = 1;

    //This means the entry should be removed from the zipfile
    public static final int REMOVE_ENTRY = 2;

    int addEntry(ZipEntry entry, InputStream is, OutputStream os);
}
