package com.sourcelabs.zipper.zip;


/**
 * Contains all the entry points into the ZipEntry that are
 * implemented by {@link java.util.zip.ZipEntry}.
 * 
 * @author willpugh  Mar 16, 2006 5:56:35 PM
 */
public class ZipEntry extends ZipEntryImpl {
    String      comment;

    public ZipEntry(String string) {
        super(string);
    }

    public ZipEntry(ZipEntry zipEntry) {
        super(zipEntry);
        comment = zipEntry.getComment();
    }

    public void setSize(long l) {
        setUncompressedSize((int)l);
    }

    public long getSize() {
        return getUncompressedSize();
    }

    public void setCrc(long l) {
        setCrc_32((int)l);
    }

    public long getCrc() {
        return getCrc_32();
    }

    public void setMethod(int i) {
        setFlags((short)i);
    }

    public int getMethod() {
        return getFlags();
    }

    public void setComment(String string) {
        comment = string;
    }

    public String getComment() {
        return comment;
    }

    public Object clone() {
        return new ZipEntry(this);
    }

}
