package com.sourcelabs.zipper;

import junit.framework.TestCase;

import java.io.*;

import com.sourcelabs.zipper.zip.ZipEntryImpl;
import com.sourcelabs.zipper.zip.ZipFile;

/**
 * @author willpugh  Mar 4, 2006 10:38:52 PM
 */
public class TestIterator extends ZipTestBase {

    public class Test1Visitor implements ZipVisitor {
        public void startEntry(ZipEntryImpl entry) {
            System.out.println("Starting : " + entry.getName());
        }

        public void data(InputStream data) {
            try {
                System.out.println("++++++++++++++++++++++++++++++++++++++++");
                BufferedReader  rdr = new BufferedReader(new InputStreamReader(data));
                while (rdr.ready()) {
                    System.out.println(rdr.readLine());
                }
                //System.out.print(str);
                System.out.println("----------------------------------------");

            } catch (IOException ioe) {
                ioe.printStackTrace();
                throw new RuntimeException(ioe);
            }
        }

        public void endEntry(ZipEntryImpl entry) {
            System.out.println("Ending : " + entry.getName());
        }
    }

    public void testOne() throws InvalidZipFormatException, IOException {
        ZipFile     zip = new ZipFile(new File(TestDataDir ,"test1.zip"));
        ZipVisitor  v = new Test1Visitor();

        zip.visitFile(v);
    }

    public void testTwo() throws InvalidZipFormatException, IOException {
        ZipFile     zip = new ZipFile(new File(TestDataDir ,"test2.zip"));
        ZipVisitor  v = new Test1Visitor();

        zip.visitFile(v);
    }

    public void testThree() throws InvalidZipFormatException, IOException {
        ZipFile     zip = new ZipFile(new File(TestDataDir ,"test3.zip"));
        ZipVisitor  v = new Test1Visitor();

        zip.visitFile(v);
    }


}
