package com.sourcelabs.zipper.zip;

import com.sourcelabs.zipper.ZipTestBase;

import java.io.*;
import java.util.zip.*;
import java.util.zip.ZipEntry;
import java.util.Enumeration;

import org.apache.commons.io.IOUtils;
import org.apache.commons.io.FileUtils;

/**
 * @author willpugh  Apr 16, 2006 9:39:23 PM
 */
public class TestModifiableZip extends ZipTestBase {


    protected void setUp() throws Exception {

    }

    //Create a new zip, and modify it
    public void testNewZip() throws IOException {

        File                f = new File(TestWorkingDir,"testNewFile");
        FileUtils.copyFile(new File(TestDataDir, "test2.zip"), f);
        //if (f.exists())
        //    f.delete();

        //Write Modifiable Zip
        ModifiableZipFile   zipFile = new ModifiableZipFile(f);

        com.sourcelabs.zipper.zip.ZipEntry    entry1 = new com.sourcelabs.zipper.zip.ZipEntry("testTextFile1.txt");
        zipFile.AddEntry(entry1, new File(TestDataDir, "testTextFile.txt"));

        com.sourcelabs.zipper.zip.ZipEntry    entry2 = new com.sourcelabs.zipper.zip.ZipEntry("ApacheLicense.txt");
        zipFile.AddEntry(entry2, ZipTestBase.TestString.getBytes());

        com.sourcelabs.zipper.zip.ZipEntry    entry3 = new com.sourcelabs.zipper.zip.ZipEntry("testTextFileFromStream.txt");
        zipFile.AddEntry(entry3, new FileInputStream(new File(TestDataDir, "testTextFile.txt")));

        zipFile.ApplyChanges();
        //comareZipFiles2(zipFile, f);
        comareZipFiles(zipFile, f);

        zipFile.ModifyEntry(entry3,  new File(TestDataDir, "testTextFile2.txt"));
        com.sourcelabs.zipper.zip.ZipEntry    entry4 = new com.sourcelabs.zipper.zip.ZipEntry("testTextFileFromStream2.txt");
        zipFile.AddEntry(entry4, new File(TestDataDir, "testTextFile.txt"));
        zipFile.ApplyChanges();
        comareZipFiles(zipFile, f);

        zipFile.ModifyEntry(entry3,  new File(TestDataDir, "testTextFile2.txt"));
        zipFile.RemoveEntry(entry2.getName());
        zipFile.RemoveEntry(entry3.getName());
        zipFile.RemoveEntry(entry4.getName());
        zipFile.ApplyChanges();
        comareZipFiles(zipFile, f);
    }

}
